<template>
  <div id="wrap" :style="cssProps">
    <coscine-page-header
      :coscineImage="coscineImage"
      :locale="this.$root.$i18n.locale"
      @changeLocale="changeLocale"
    />
    <br />
    <coscine-notification-banner
      v-show="displayMaintenceNotice"
      id="notificationBanner"
      :bannerText1="maintenanceNotices"
      :bannerText2="maintenanceNoticesEnd"
      :linkText="maintenanceLinkText"
      :bannerLink="bannerLink"
      :visible="true"
      :dismissable="false"
    />
    <div class="container-fluid app-content">
      <div class="row">
        <div class="col-xl-2"></div>
        <div class="col-xl-8">
          <h1 class="headline">
            {{ $t("headline") }}
            <img class="logo" :src="coscineImageBlue" v-if="imageEnabled" alt />
          </h1>
          <div v-if="!tos" class="row">
            <div class="col-sm-12 col-md-7">
              <div class="alert alert-warning" role="alert">
                <h5 class="alert-heading">{{ $t("alert_headline") }}</h5>
                <p class="alert-title">
                  {{ $t("alert_text1") }}
                  <a
                    href="mailto:servicedesk@rwth-aachen.de?subject=Coscine%20Pilot%20Program"
                    >IT-ServiceDesk</a
                  >
                  {{ $t("alert_text2") }}
                </p>
              </div>
              <div class="card bg-light mb-3 w-100">
                <div class="card-body">
                  <h5 class="card-title">
                    {{ $t("coscineReleaseNewsTitle") }}
                  </h5>
                  <i18n path="coscineReleaseNewsBody" tag="p" class="card-text">
                    <a place="mailingList" :href="$t('coscineMailingListUrl')">{{ $t("coscineMailingList") }}</a>
                  </i18n>
                </div>
              </div>
            </div>
            <div class="col-sm-12 col-md-5">
              <div class="row">
                <div class="card bg-light w-100" style="margin-bottom: 1rem">
                  <div class="card-body">
                    <transition name="component-fade" mode="out-in">
                      <component
                        :is="logoutState ? logoutComponent : currentInputCard"
                        :returnUrl="this.returnUrl"
                        :idpUrl="this.idpUrl"
                        :loggedInWithShibboleth="this.loggedInWithShibboleth"
                        :mergeReturnUrl="mergeReturnUrl"
                        @back="loginBack"
                        @clickGetORCiDForm="getORCiDForm"
                        @changeLogoutState="changeLogoutState"
                      />
                    </transition>
                  </div>
                </div>
              </div>
              <div class="row">
                <button
                  hidden
                  class="btn btn-secondary dropdown-toggle w-100"
                  id="signup-toggle"
                >
                  {{ $t("signup") }}
                </button>
              </div>
              <div class="row">
                <div class="card bg-light mb-3 w-100">
                  <div class="card-body">
                    <h5 class="card-title">{{ $t("description_headline") }}</h5>
                    <p class="card-text">{{ $t("description_text") }}</p>
                    <h5 class="card-title">
                      {{ $t("description_help_headline") }}
                    </h5>
                    <p class="card-text">
                      {{ $t("description_help") }}
                      <a :href="getCoscineHelpPageUrl()">{{
                        $t("coscineHelpPage")
                      }}</a>
                    </p>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div v-else class="row">
            <div class="col-sm-12 col-md-12">
              <TOS :tosReturnUrl="this.tosReturnUrl" />
            </div>
          </div>
        </div>
      </div>
      <div class="col-xl-2"></div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import VueMarkdown from "vue-markdown";
import LoginMain from "./components/LoginMain.vue";
import LogoutMain from "./components/LogoutMain.vue";
import TOS from "./components/TOS.vue";
import {
  CoscinePageHeader,
  CoscineNotificationBanner,
} from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";
import coscineImageBluePath from "./assets/rwth_coscine_rgb.svg";
import coscineImagePath from "./assets/rwth_coscine_weiss_rgb.svg";
import linkWhitePath from "./assets/link_white.svg";
import mailGreyPath from "./assets/mail_grey.svg";
import phoneGreyPath from "./assets/phone_grey.svg";
import faxGreyPath from "./assets/fax_grey.svg";

import { NoticeApi } from "@coscine/api-connection";
import * as linkUtil from "./util/linkUtil";

let scriptPath = "";
let imageEnabled = false;
if (document.currentScript !== undefined) {
  scriptPath = (document.currentScript as any).src as string;
  imageEnabled = true;
}
const scriptUrl =
  scriptPath === ""
    ? "/"
    : scriptPath.substring(0, scriptPath.indexOf("app.js"));
const rootUrl =
  scriptPath.indexOf("/js") !== -1 ? scriptUrl.replace("/js", "") : scriptUrl;

export default Vue.extend({
  name: "loginapp",
  components: {
    LoginMain,
    LogoutMain,
    TOS,
    VueMarkdown,
    CoscinePageHeader,
    CoscineNotificationBanner,
  },
  computed: {
    cssProps() {
      return {
        "--linkWhite": "url(" + rootUrl + linkWhitePath + ") 1px 9px no-repeat",
        "--mailGrey": "url(" + rootUrl + mailGreyPath + ") 0px 6px no-repeat",
        "--phoneGrey": "url(" + rootUrl + phoneGreyPath + ") 0px 6px no-repeat",
        "--faxGrey": "url(" + rootUrl + faxGreyPath + ") 0px 6px no-repeat",
      };
    },
  },
  data() {
    return {
      bannerLink: "",
      maintenanceNotices: "",
      maintenanceNoticesEnd: "",
      maintenanceLinkText: "",
      coscineImageBlue: rootUrl + coscineImageBluePath,
      coscineImage: rootUrl + coscineImagePath,
      imageEnabled,
      returnUrl: linkUtil.getAccountReturnUrl(),
      tosReturnUrl: linkUtil.getTOSReturnUrl(),
      mergeReturnUrl: linkUtil.getMergeReturnUrl(),
      idpUrl: linkUtil.getIdpUrl(),
      orcidUrl: linkUtil.getORCiDUrl(),
      logoutState: linkUtil.getIsLogout(),
      loggedInWithShibboleth: linkUtil.getLoggedInWithShibboleth(),
      currentInputCard: "LoginMain",
      logoutComponent: "LogoutMain",
      tos: linkUtil.getIsTOS(),
      storedUrl: {} as any,
      displayMaintenceNotice: false,
      dropdown: false,
    };
  },
  watch: {
    "$i18n.locale"() {
      this.retrieveMaintenanceNotices();
    },
  },
  methods: {
    retrieveMaintenanceNotices() {
      NoticeApi.GetMaintenance((response: any) => {
        if (
          response.data.startsDate !== null &&
          response.data.startsDate !== undefined
        ) {
          this.displayMaintenceNotice = true;
          var now = new Date(Date.now());
          var startDate = new Date(response.data.startsDate);
          var endDate = response.data.endsDate;
          if (
            startDate <= now &&
            (endDate === null || new Date(endDate) >= now)
          ) {
            this.bannerLink = response.data.url;
            this.maintenanceNotices = this.createNotificationText(
              response.data.type
            );
            this.maintenanceNoticesEnd = this.createNotificationEndText(
              response.data.type
            );
            this.maintenanceLinkText = this.createNotificationLinkText(
              response.data.type
            );
          }
        }
      });
    },
    createNotificationText(type: any): any {
      switch (type) {
        case "Eingriff":
          return this.$t("banner.maintenance.notificationDeployment");
        case "Störung":
          return this.$t("banner.maintenance.notificationMaintenance");
        case "Teilstörung":
          return this.$t("banner.maintenance.notificationPartiaMulfunction");
        case "Unterbrechung":
          return this.$t("banner.maintenance.notificationInteruption");
        case "eingeschränkt betriebsfähig":
          return this.$t("banner.maintenance.notificationLimitedOperability");
        case "Wartung":
          return this.$t("banner.maintenance.notificationMaintenance");
        case "Teilwartung":
          return this.$t("banner.maintenance.notificationPartialMaintenance");
        default:
          return this.$t("banner.maintenance.notificationDefaultText");
      }
    },
    createNotificationEndText(type: any): any {
      if (type == "Eingriff") {
        return "";
      } else {
        return this.$t("banner.maintenance.notificationEndText");
      }
    },
    createNotificationLinkText(type: any): any {
      if (type == "Eingriff") {
        return "";
      } else {
        return this.$t("banner.maintenance.moreInformation");
      }
    },
    loginBack() {
      this.currentInputCard = "LoginMain";
    },
    getORCiDForm() {
      window.location.href = this.orcidUrl;
    },
    changeLogoutState() {
      this.logoutState = !this.logoutState;
    },
    changeLocale() {
      if (this.$root.$i18n.locale === "en") {
        this.$root.$i18n.locale = "de";
      } else {
        this.$root.$i18n.locale = "en";
      }
    },
    getCoscineHelpPageUrl() {
      if (this.$root.$i18n.locale === "en") {
        return "https://docs.coscine.de/en/";
      }
      else if (this.$root.$i18n.locale === "de") {
        return "https://docs.coscine.de/de/";
      }
    },
  },
  created() {
    this.retrieveMaintenanceNotices();
  },
});
</script>

<style>
.list-group-item-action {
  background: var(--linkWhite) !important;
}

#mail.list-group-item-action {
  background: var(--mailGrey) !important;
}
#phone.list-group-item {
  background: var(--phoneGrey) !important;
}
#fax.list-group-item {
  background: var(--faxGrey) !important;
}

#wrap .navbar .lang {
  padding-top: 0.5rem !important;
}

.siteIcon {
  height: 0px;
  width: 0px;
  overflow: visible;
  margin-left: 150px;
  line-height: 0px;
  margin-top: -20px;
}

.coscineSiteIcon {
  height: 0px;
  width: 0px;
  overflow: visible;
  line-height: 0px;
}

.coscineSiteIcon img {
  margin-left: 8px;
  height: 36px;
  width: 36px;
}

.coscineSiteIcon img {
  margin-left: 8px;
  height: 36px;
  width: 36px;
}

.coscineSiteIconLabel {
  margin-left: 8px;
  vertical-align: middle;
  color: white;
  font-size: 22px;
}

.navbar .app-header-container a img.ms-siteicon-img {
  border: 0px;
}

#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}

.headline {
  text-align: left;
  padding-left: 0;
  margin-bottom: 1em;
}

.logo {
  margin-bottom: 0.16em;
  width: 3.5em;
}

.keyword {
  color: #00549f;
}

.card-title {
  text-align: left;
  padding: 0em 0.2em;
}

.card-text {
  text-align: left;
  padding: 0em 0.4em;
}

.component-fade-enter-active,
.component-fade-leave-active {
  transition: opacity 0.3s ease;
}

.component-fade-enter,
.component-fade-leave-to {
  opacity: 0;
}

#signup-toggle {
  margin: 0em;
}

.alert-heading {
  text-align: left;
  border-radius: 0.2rem;
}
.alert-title {
  text-align: left;
  border-radius: 0.2rem;
}
#notificationBanner {
  margin-bottom: 4px;
  margin-top: 26px;
}

.multiselect__option--highlight {
  background: #00549f;
}
.multiselect__option--selected.multiselect__option--highlight {
  background: #00549f;
}
.multiselect__content-wrapper {
  overflow-x: hidden;
  text-overflow: ellipsis;
}
</style>
